sceneController =  gideros.class(Sprite)

local pages = {}
-- create a list of pages, to set their order of apperance. 
pages[1] = "Page0"
pages[2] = "Page1"

function sceneController:init()
	self.scenes = SceneManager.new({ --scenes are defined
	["Page0"] = Page0, 	
	["Page1"] = Page1,
})
	--music = Sound.new("sounds/theme_music.mp3")	
	--local channel  = music:play(0, 1000)
	--channel:setVolume(0.4)
	
	self:addChild(self.scenes)
	-- add the first page
	self.scenes:changeScene("Page0")
	self.pageNo = 1

	-- this is the button on the left. to go back
	self.left = Button.new(Bitmap.new(Texture.new("images/buttons/left-up.png")), Bitmap.new(Texture.new("images/buttons/left-down.png")))
	--bottom left 
	self.left:setPosition(-conf.dx, conf.dy + application:getContentHeight() - self.left:getHeight()) 
	self:addChild(self.left)

	-- thins is the button on the right, to go fprward. 
	self.right = Button.new(Bitmap.new(Texture.new("images/buttons/right-up.png")), Bitmap.new(Texture.new("images/buttons/right-down.png")))
	--bottom right 
	self.right:setPosition(conf.dx + application:getContentWidth()-self.right:getWidth(), conf.dy + application:getContentHeight() - self.right:getHeight())
	self:addChild(self.right)
	
	-- "click" event is mapped to the function of scenecontroller, self.leftClick
	-- when the "click" event is pressed, this function will be called.
	self.left:addEventListener("click", self.leftClick, self)
	self.right:addEventListener("click", self.rightClick, self)
	self:addEventListener(Event.KEY_UP, self.onKeyUp, self)	
end

function sceneController:onKeyUp(event)
	if event.keyCode == KeyCode.BACK then
		if application:getDeviceInfo() == "Android" then
			application:exit()
		end
	end
end

function sceneController:leftClick()
	print(self.pageNo)
	-- previous index
	self.pageNo = self.pageNo - 1
	if self.pageNo < 1 then self.pageNo = 1 end	
	print(self.pageNo)
	-- give next scene, the duration, the effect, and the easing mode. you can play with them to see how they look.
	self.scenes:changeScene(pages[self.pageNo],1, SceneManager.flipWithShade, easing.inBack) 
end 

function sceneController:rightClick()
	self.pageNo = self.pageNo + 1
	if self.pageNo > 5 then self.pageNo = 1 end
	self.scenes:changeScene(pages[self.pageNo], 1, "PageCurl", easing.inBack) 
end 
